package nxm.sys.inc;

/** A class to define all file methods needed by a file that can be listed with <code>LIST2</code>.
    This interface is also used by other primitives that work with record-based data. The methods
    specified here provide a very basic way to work with record-based data, other classes (such
    as {@link nxm.sys.lib.DataFile}) may provide additional methods that may be useful.<br>
    <br>
    <b>Note:</b> It is common for primitives that use this interface to expect the file to also
    extend the {@link nxm.sys.lib.BaseFile} class.

    @author  J. Czechowski IV
    @version $Id: ListFile.java,v 1.17 2012/01/31 15:44:31 ntn Exp $
    @since   NeXtMidas 2.1.0
*/
public interface ListFile extends RecordFileRW {

}
