package nxm.sys.libg;

import java.awt.Point;

/**  A class to define a point representing a location in (<I>x</I>, <I>y</I>) coordinate space. <br>
     <br>
     This class is functionally identical to {@link Point}. Since NeXtMidas 2.7.0, this class has
     extended {@link Point} with the goal of deprecating and eventually removing this class, in
     favor of just using {@link Point}.

     @author  Jeff Schoen
     @version $Id: MPoint.java,v 1.5 2012/02/10 19:58:00 ntn Exp $
 */
public class MPoint extends Point {
  /** NOTE: this should be changed if the structure/fields of this class changes. */
  private static final long serialVersionUID = 2012021120311L; // for Serializable interface

  /** Creates a new MPoint with coordinates (0,0). */
  public MPoint () {
    super();
  }

  /** Creates a new MPoint with coordinates (<I>x</I>, <I>y</I>).
      @param x the <I>x</I> coordinate
      @param y the <I>y</I> coordinate
   */
  public MPoint (int x, int y) {
    super(x,y);
  }

  /** Returns a string representation of this MPoint and its location.
      @return A string representation of the MPoint.
   */
  public String toString () {
    return "Point ("+x+","+y+")";
  }
}
