package nxm.sys.libg;

/** A class to run a graphical Midas Panel. This class is implemented using
    swing components while {@link MPanel} uses AWT. <br>
    <br>
    Additionally (since NeXtMidas 1.9.2) this class has the ability to act as a
    {@link nxm.sys.libg.MidasFrame} which is used to enable the creation of swing-based Java
    bean components (see {@link MidasBean}).

    @see MWindow
    @see MPanel
    @see MidasBean

    @author  J. Czechowski
    @since   NeXtMidas 1.9.2
 */
public class MidasControls extends MidasDisplay {
  /** NOTE: this should be changed if the structure/fields of this class changes. */
  private static final long serialVersionUID = 2012020920311L; // for Serializable interface

  /** Initializes the display. */
  public MidasControls() {
    super("MidasControls");
  }

  /** Gets the Midas Window being used.
      @return The Midas Window being used or <code>null</code> if not yet set.
   */
  public MWindow getMWindow() {
    return this.MW;
  }
}
