!************
!
!  2020-06-26: ported from X-Midas
!
!  Description: Includes Midas SYS area version constants and defines the
!  M_PTR pointer struct type for storing pointers in FORTRAN structures.
!
!  Author:	JGS 4/2/90
!  
!  Modified:    DR 791176 12-May-2010 BWC - Increased L_max_ascii to 256
!
!************

	include 'xmversion.inc'

! pointer definition
	integer*4 L_M_Ptr
	parameter (L_M_Ptr = 8)

!if _64BIT

	integer*4 L_M_Ptr_p
	parameter (L_M_Ptr_p = 8)
	structure /M_PTR/
	  integer*8 p
	end structure

!else
!
!
!
!
!
!
!
!
!endif

! parameters

	integer*4 L_max_ascii	! max size of ascii result string
	parameter (L_max_ascii = 256)
	integer*4 L_max_resname	! max size of results name
	parameter (L_max_resname = 40)
                                ! should match L_basic_name in midas.ildp
	integer*4 L_big_string   ! Size of long filenames etc.
	parameter (L_big_string = 1024)
