package nxm.sys.inc;

import nxm.sys.libg.Line;
import nxm.sys.libg.MPlot;
/** ******************** STANDARD VERSION ****************
 *
 *  @author Jeanette McCall
 *  @since NeXtMidas 4.0.0
 *
 */
interface DrawableModSwap {

  /** Gets the line used for drawing this drawable instance.
   *  @return The line used for drawing this drawable instance.
   *  @since NeXtMidas 3.5.4
   *  @deprecated since NeXtMidas 3.9.2 for Java 11 Modularity
   */
  @InternalUseOnly("Since added")
  @Deprecated
  Line getLine ();

  /** Gets the plot this drawable is part of.
   *  @return The plot this drawable is part of. This will be null if not set yet.
   *  @since NeXtMidas 3.5.4
   *  @deprecated since NeXtMidas 3.9.2 for Java 11 Modularity
   */
  @Deprecated
  @InternalUseOnly("Since added")
  MPlot getMPlot (); // new to Layer in 3.5.4, has been in Feature for a long time

  /** Sets the plot this drawable is part of.
   *  @param plot The plot this drawable is part of.
   *  @since NeXtMidas 3.5.4
   *  @deprecated since NeXtMidas 3.9.2 for Java 11 Modularity
   */
  @Deprecated
  @InternalUseOnly
  void setMPlot (MPlot plot);

}
