package nxm.sys.inc;

import java.lang.annotation.Documented;
import java.lang.annotation.Inherited;
import java.lang.annotation.Retention;
import java.lang.annotation.RetentionPolicy;

/** Marker annotation for Java methods that remain for legacy support, but for
 *  which there is a suggested alternate.
 *  @author  Jeanette McCall
 *  @since   NeXtMidas 3.9.2
 */
@Documented
@Inherited
@Retention(RetentionPolicy.RUNTIME)
//@Target is specifically omitted as omitting it permits all targets
public @interface LegacyMethod {
  /** Description of the provisional designation. The preferred forms for this designation are:
   *  <pre>
   *    "Added in NeXtMidas x.y.z"
   *    "Added in NeXtMidas x.y.z: [details]"
   *  </pre>
   *  @return Description of the provisional designation.
   */
  String value ();
}
