package nxm.sys.inc;

import nxm.sys.libg.GWidget;

/** ***************** STANDARD VERSION *****************
  Interface Definitions for Widget Panels.

  @author Jeff Schoen
*/

@LimitedFutureSupport("Being replaced by libg.WidgetPanel. See JDK_Modularity_User_Action_Required.xlxs for more details - since 3.9.2")
public interface WidgetPanel {

  /** Adds a widget to the panel. <br>
      <b>Note:</b> To avoid a possible race condition, this method should always be called by the EDT.

      @param obj The widget to add.
      @return <code>obj</code> after it has been added.
   */
  Object addWidget (GWidget obj);

  /** Layout widget panel.
      @param obj The widget to layout in the panel.
   */
  void layoutWidget (GWidget obj);
}