c Include file for the assertion facility used when testing
c from Fortran.
c
c Typical usage:
c
c        program MYPRIM
c          implicit none
c          include 'primitive.inc'
c          include 'assert.inc'
c
c          call M$CHECKIN
c
c          call ASSERT_AUTOINIT('DEBUG','STAT')
c
c          call M$SYNC
c
c          ! Run tests here
c          call ASSERT('description', (1.eq.1))
c
c          call M$RETURN
c          call ASSERT_AUTOREPORT()
c        end
c
c        ! Put subroutines/functions here
c
c        include 'assert.for'
c
c @author J. Czechowski IV / Jay Hallam
c @version $Id: assert.inc,v 1.3 2007/11/02 20:00:16 jxc Exp $
c

c.. Structures
      structure /ASSERT_STRUCT/ 
        logical*4  verbose
        integer*4  num_tests
        integer*4  num_failed
        integer*4  res_name_len
        character*(36) res_name
      end structure

c.. Functions
      integer*4 ASSERT_getNumTests
      integer*4 ASSERT_getNumFailed

c.. Commons
      record /ASSERT_STRUCT/ assertRec
      common /ASSERT_COMMON/ assertRec
