#!/bin/bash
#################EXPERIMENTAL PURPOSES ONLY###################
#                                                            #
# This script moves the original nxm.sys.dat directory under #
# nxm.sys.test, and vice versa                               #
#                                                            #
# Environment Variables:                                     #
#   NMROOT - Current NeXtMidas distribution                  #
#                                                            #
# Author: Zachary Matthews                                   #
# Since:  NeXtMidas 4.0.0                                    #
#                                                            #
##############################################################

sysDir=$NMROOT/nxm/sys
origDatDir=$NMROOT/nxm/sys/dat
testDir=$NMROOT/nxm/sys/test

if [ ! -d $testDir/dat ] ; then
  echo "Moving nxm.sys.dat into nxm.sys.test"
  mv $origDatDir $testDir
  mkdir $origDatDir
  filesToKeep=(kwconv_plat2blue.tbl testxy3000.prm world.dbf world.shp world.shx)
  for file in ${filesToKeep[@]}
  do
    cp $testDir/dat/$file $origDatDir
  done
else
  echo "Moving nxm.sys.test.dat back into nxm.sys"
  rm -rf $origDatDir
  mv $testDir/dat $sysDir
fi
